#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

//---- input parameters
extern int AtrPeriod=14;
//---- buffers
double AtrBuffer[];
double TempBuffer[];
double MaBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
//---- indicator line
   SetIndexBuffer(0,AtrBuffer);
   SetIndexBuffer(1,MaBuffer);
   SetIndexBuffer(2,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="ATR("+AtrPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,AtrPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if (Bars<=AtrPeriod) return(0);
      if (counted_bars>0) counted_bars--;
         int limit=Bars-counted_bars;

   for(i=limit; i>=0; i--)
   {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
      {
         double prevclose=Close[i+1];
         TempBuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
      }
   }
   for(i=limit; i>=0; i--) AtrBuffer[i] = iMAOnArray(TempBuffer,0,AtrPeriod,0,MODE_SMA,i);
   for(i=limit; i>=0; i--) MaBuffer[i]  = iMAOnArray(AtrBuffer,0,10,0,MODE_SMA,i);
   return(0);
}